#include "movement.h"

#include <cmath>

#include "entity.h"
#include "random.h"

namespace el {

void up(Entity *e) { e->y-=0.1f; }
void down(Entity *e) { e->y+=0.1f; }
void left(Entity *e) { e->x-=0.1f; }
void right(Entity *e) { e->x+=0.1f; }


void upleft(Entity *e) { e->y-=0.1f; e->x+=0.1f; }
void downleft(Entity *e) { e->y+=0.1f; e->x+=0.1f; }

void upright(Entity *e) { e->y-=0.1f; e->x-=0.1f; }
void downright(Entity *e) { e->y+=0.1f; e->x-=0.1f; }

void mov_random(Entity *e) {
	float dirs[5][2]={{0.1f,0},{0,0.1f},{-0.1f,0},{0,-0.1f},{-0.1f,0}};
	int r;
	r=e->rg->get(5);

	e->x+=dirs[r][0];
	e->y+=dirs[r][1];
}

void mov_sin(Entity *e) {
	e->x+=-0.1f;
	e->y+=sinf(e->x/3.0);
}

void mov_sincos(Entity *e) {
	e->x+=-0.1f;
	if (e->rg->get(2)==0) {
		e->y+=sinf(e->x/3.0);
	} else {
		e->y+=cosf(e->x/3.0);
	}

}

void mov_skewbackup(Entity *e) {
	e->x+=-0.1f;
	if (e->rg->get(300)==0) {
		e->x+=3.0f;
		e->y-=1.0f;
	}
}
void mov_skewbackdown(Entity *e) {
	e->x+=-0.1f;
	if (e->rg->get(300)==0) {
		e->x+=3.0f;
		e->y+=1.0f;
	}
}

void mov_skewup(Entity *e) {
	e->x+=-0.1f;
	if (e->rg->get(300)==0) {
		e->y-=1.0f;
	}
}
void mov_skewdown(Entity *e) {
	e->x+=-0.1f;
	if (e->rg->get(300)==0) {
		e->y+=1.0f;
	}
}

void mov_diagonalrandom(Entity *e) {

	if (e->rg->get(30)==2) {
		e->movementdata=-1;
	}

	e->x+=-0.1f;
	switch (e->movementdata) {
		case 0: e->y+=-0.1f; break;
		case 1: e->y+=0.1f; break;
		default:
			e->movementdata=e->rg->get(2);
			break;
	}

}


}
