#include <vector>

#include "SDL.h"
#include "SDL_image.h"


#include "res.h"



namespace el {
std::vector <SDL_Surface *>imgs;


int res::num() {
	return imgs.size();
}

SDL_Surface *res::get(int i) {
	if (i<0||i>=imgs.size()) {
		std::cerr << "requesting invalid res " << i << std::endl;
		return NULL;
	}
	return imgs[i];
}
void load_image(std::string fn) {
	SDL_Surface *s,*tmp;

	tmp=IMG_Load(fn.c_str());
	if (tmp==NULL) {
		std::cerr << "\t ... loading failed " << fn << std::endl;
		return;
	}
	s=SDL_DisplayFormatAlpha(tmp);
	if (s==NULL) return;
	imgs.push_back(s);
}

bool res::load() {
	load_image("data/spieler.png");
	load_image("data/800px-Karte_Baeke1.jpg");
	load_image("data/800px-Karte_Baeke1.jpg");
	load_image("data/explosion.png");
	load_image("data/CleverHans.jpeg");
	load_image("data/Knudaheio.jpg");
	load_image("data/Lightning_over_Oradea_Romania_2.jpg");
	load_image("data/Siemensstern_gross.png");
	load_image("data/Triangulum.nebula.full.jpg");
	load_image("data/Mekhnes_Place_El-Hedine_Mosaique2.jpg");
	load_image("data/800px-Tygodnik_Solidarnosc_1981_lipiec.jpg");
	/*load_image("data/spieler.bmp");
	load_image("data/800px-Karte_Baeke1.bmp");
	load_image("data/800px-Karte_Baeke1.bmp");
	load_image("data/explosion.bmp");
	load_image("data/CleverHans.bmp");
	load_image("data/Knudaheio.bmp");
	load_image("data/Lightning_over_Oradea_Romania_2.bmp");
	load_image("data/Siemensstern_gross.bmp");
	load_image("data/Triangulum.nebula.full.bmp");
	load_image("data/Mekhnes_Place_El-Hedine_Mosaique2.bmp");
	load_image("data/800px-Tygodnik_Solidarnosc_1981_lipiec.bmp");*/

	std::cout << "resources loaded: " << num() << std::endl;
	if (num()!=11) {
		std::cerr << " invalid ressource count ... should be 11 " << std::endl;
		return false;
	}
	return true;
}



std::ostream& operator<<(std::ostream&s, res sk) {
	return s;
}

} //namespace
